=== debian/changelog ===
dpkg (1.18.2ubuntu5.1) wily-security; urgency=medium

  * SECURITY UPDATE: multiple security issues
    - dpkg-deb/extract.c: Fix off-by-one write access on ctrllenbuf
      variable. (CVE-2015-0860)
    - lib/dpkg/ar.c: Fix an off-by-one read access in ar member name
      variable.
    - Thanks to Guillem Jover and Hanno Böck for the patches!

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 26 Nov 2015 08:00:10 -0500

dpkg (1.18.2ubuntu5) wily; urgency=medium

  * Pull packaging changes from 1.18.3 to fix libdir issues (LP: #1504761)
  * Fix an off-by-one write access in dpkg-deb when parsing the deb magic.
  * Fix a segfault when using «dpkg --no-act» with a synthetic --admindir.

 -- Adam Conrad <adconrad@ubuntu.com>  Sat, 17 Oct 2015 12:47:12 -0600

dpkg (1.18.2ubuntu4) wily; urgency=medium

  * Add a Breaks on software-center (<< 13.10-0ubuntu9~) for trigger loops.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 11 Sep 2015 11:11:01 -0600

dpkg (1.18.2ubuntu3) wily; urgency=medium

  * Cherrypick fix from git to be less strict about week day parsing.
  * Extend the above to also be less strict about month name parsing.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 26 Aug 2015 16:39:42 -0600

dpkg (1.18.2ubuntu2) wily; urgency=medium

  * Add a Breaks on dbus (<< 1.8.12-1ubuntu6~) to avoid the noawait trigger.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 18 Aug 2015 13:51:02 -0600

dpkg (1.18.2ubuntu1) wily; urgency=medium

  * Merge with Debian unstable, bringing in a whole host of new bugfixes.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 13 Aug 2015 02:05:42 -0600

dpkg (1.18.2) unstable; urgency=low

  [ Guillem Jover ]
  * Fix plural form translations for single plural languages. Closes: #790025
  * Add new dpkg-buildpackage -J option, which is a safe version of -j.
  * Fix dpkg-gencontrol to add correct binary filename to debian/files,
    even when overriding the Package field value with the -D option.
    Reported by Niels Thykier <niels@thykier.net>.
  * Move the implicit build-essential:native Build-Depends from
    dpkg-checkbuilddeps to a new vendor hook, as it is Debian-specific.
  * Add support for ignoring built-in build dependencies and conflicts
    with the new «dpkg-buildpackage --ignore-builtin-builddeps» and
    «dpkg-checkbuilddeps -I» options. Closes: #480638, #571671
  * When sys_siglist is defined in the system, try to use NSIG as we cannot
    compute the array size with sizeof(). If NSIG is missing fallback to 32
    items. Prompted by Igor Pashev <pashev.igor@gmail.com>.
  * Use string_to_security_class() instead of a literal SECCLASS value in
    the setexecfilecon() libcompat function, as <selinux/flask.h> is now
    deprecated.
  * Switch libdpkg xz compressor to use CRC64 for integrity checks, to match
    the default on the command-line tool, which should provide slightly better
    detection against damaged data, at a negligible speed difference.
  * Only use the SHELL environment variable for interactive shells.
    Closes: #788819
  * Move tar option --no-recursion before -T in dpkg-deb. With tar > 1.28 the
    --no-recursion option is now positional, and needs to be passed before
    the -T option, otherwise the tarball will end up with duplicated entries.
    Thanks to Richard Purdie <richard.purdie@linuxfoundation.org>.
  * Add an extra level of escaping for double $(evals) in architecture.mk
    and buildflags.mk, so that the variables are computed lazily again.
    Regression introduced in dpkg 1.16.2. Closes: #793330
  * Add binary packages Essential information to Package-List field in the
    .dsc file, as optional essential=yes entries. This allows precomputing
    the pseudo-essential set before starting an architecture bootstrap.
  * Perl modules:
    - Remove non-functional timezone name support from
      Dpkg::Changelog::Entry::Debian.
    - Use Time::Piece (part of the perl core distribution) instead of
      Date::Parse in Dpkg::Changelog::Entry::Debian. This reduces the build
      and run-time dependencies, and helps architecture bootstrapping.
    - Simplify distribution splitting in Dpkg::Changelog::Entry::Debian.
    - Add new function changelog_parse_plugin() in Dpkg::Changelog::Parse.
    - Add new function changelog_parse_debian() in Dpkg::Changelog::Parse, and
      use it in changelog_parse() instead of the external plugin parser when
      the input format is “debian”. This significantly speeds up the parsing.
    - Remove trailing space before handling blank line dot-separator in
      Dpkg::Control::HashCore. Regression introduced in dpkg 1.18.0.
      Reported by Jakub Wilk <jwilk@debian.org>. Closes: #789580
    - Allow the Maintainer field in CTRL_FILE_STATUS.
    - Import make_path from File::Path in Dpkg::Source::Package::V2.
      Regression introduced in dpkg 1.18.0. Closes: #789957
    - Make the BinaryFiles subpackage self-contained by explicitly importing
      File::Spec in Dpkg::Source::Package::V2.
    - Do not exclude pre-existing symlinks when unpacking the debian/ tarball
      in Dpkg::Source::Package::V2. Closes: #790073, #791535
    - Disable the thread sanitizer when the address sanitizer is enabled
      in Dpkg::Vendor::Debian as these are mutually incompatible, and make
      sanitize=+all not work at all.
    - Allow colons (:) in added filenames in Dpkg::Dist::Files, which can be
      present when the upstream version contains colons. Regression introduced
      in dpkg 1.18.0. Reported by Jakub Wilk <jwilk@debian.org>.
    - Future-proof tar invocations in Dpkg::Source::Archive for options that
      might become positional in the future, and by always placing function
      options first.
    - Make the dependency comparison deep by comparing not only the first
      dependency alternative, to get them sorted in a reproducible way.
      Based on a patch by Chris Lamb <lamby@debian.org>. Closes: #792491
    - Support spaces in symbol names in Dpkg::Shlibs::Objdump. This is

