=== examples/live-config-foobar/debian/changelog ===
live-config-foobar (4-1) unstable; urgency=low

  * Initial release based on the live-config-foobar example package
    included in live-config.

 -- John Doe <john@example.org>  Wed, 01 Jan 2014 00:00:00 +0100
