=== watch ===
# Site		Directory		Pattern			Version	Script
version=3
http://pkgs.fedoraproject.org/repo/pkgs/libaio/libaio-([\d\.]+)\.tar\.gz/(?:[\da-f]+)/libaio-([\d\.]+)\.tar\.gz debian uupdate
#http://ftp.kernel.org/pub/linux/libs/aio/ libaio-([\d\.]+)\.tar.gz debian uupdate
